window.Gleam.initSearch([{"doc":"glimpse_log","title":"glimpse_log","content":"# glimpse_log\n\n[![Package Version](https://img.shields.io/hexpm/v/glimpse_log)](https://hex.pm/packages/glimpse_log)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glimpse_log/)\n\nA minimal cross-target gleam logging library that helps you get a glimpse into the program. Contains bindings to JavaScript and a gleam implementation for everywhere else.\n\nNote that this is (at least currently) just a nicer API, if you want to customize output (erlang only) you will want to set up a library such as [lpil/logging](https://hexdocs.pm/logging/).\n\n```sh\ngleam add glimpse_log@1\n```\n```gleam\nimport glimpse\n\npub fn main() {\n  // You can call this on any value that can be converted to a StringBuilder via string.inspect()\n  glimpse.error(&quot;An error log&quot;)\n  glimpse.warn(&quot;A warning log&quot;)\n  glimpse.info(&quot;An info log&quot;)\n  glimpse.debug(&quot;A debug log&quot;)\n\n  // The functions return the term passed into them, so they can be used in pipes!\n  &quot;A value&quot;\n  |&gt; glimpse.error\n  |&gt; glimpse.warn\n  |&gt; glimpse.info\n  |&gt; glimpse.debug\n\n  4\n  |&gt; glimpse.info\n}\n\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glimpse_log&gt;.\n\n## Development\n\nTODO\n\n- Tests\n- Docs\n- Format Errors (Erlang: `info(Format,Args[,Metadata])`) [ref](https://www.erlang.org/docs/24/man/logger#info-2)\n- Metadata for erlang logger\n- format args for JS\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"internal","title":"erlang_debug_fun","content":"pub fn erlang_debug_fun(fun: fn(a) -&gt; String) -&gt; Nil\n\nSynonyms:\ninternal.erlang_debug_fun\ninternal erlang_debug_fun","url":"internal.html#erlang_debug_fun"},{"doc":"internal","title":"erlang_debug_string","content":"pub fn erlang_debug_string(string: String) -&gt; Nil\n\nSynonyms:\ninternal.erlang_debug_string\ninternal erlang_debug_string","url":"internal.html#erlang_debug_string"},{"doc":"internal","title":"erlang_error_format","content":"pub fn erlang_error_format(\n  format: String,\n  args: List(String),\n) -&gt; Nil\n Unstable - do not use\nSynonyms:\ninternal.erlang_error_format\ninternal erlang_error_format","url":"internal.html#erlang_error_format"},{"doc":"internal","title":"erlang_error_fun","content":"pub fn erlang_error_fun(\n  fun: fn(a) -&gt; String,\n  args: List(a),\n) -&gt; Nil\n Unstable - do not use\nSynonyms:\ninternal.erlang_error_fun\ninternal erlang_error_fun","url":"internal.html#erlang_error_fun"},{"doc":"internal","title":"erlang_error_string","content":"pub fn erlang_error_string(string: String) -&gt; Nil\n\nSynonyms:\ninternal.erlang_error_string\ninternal erlang_error_string","url":"internal.html#erlang_error_string"},{"doc":"internal","title":"erlang_info_fun","content":"pub fn erlang_info_fun(fun: fn(a) -&gt; String) -&gt; Nil\n\nSynonyms:\ninternal.erlang_info_fun\ninternal erlang_info_fun","url":"internal.html#erlang_info_fun"},{"doc":"internal","title":"erlang_info_string","content":"pub fn erlang_info_string(string: String) -&gt; Nil\n\nSynonyms:\ninternal.erlang_info_string\ninternal erlang_info_string","url":"internal.html#erlang_info_string"},{"doc":"internal","title":"erlang_warning_fun","content":"pub fn erlang_warning_fun(fun: fn(a) -&gt; String) -&gt; Nil\n\nSynonyms:\ninternal.erlang_warning_fun\ninternal erlang_warning_fun","url":"internal.html#erlang_warning_fun"},{"doc":"internal","title":"erlang_warning_string","content":"pub fn erlang_warning_string(string: String) -&gt; Nil\n\nSynonyms:\ninternal.erlang_warning_string\ninternal erlang_warning_string","url":"internal.html#erlang_warning_string"},{"doc":"internal","title":"internal","content":"","url":"internal.html"},{"doc":"glimpse","title":"debug","content":"pub fn debug(term term: a) -&gt; a\n Used for finding whats going on in your code. Generally these are best\n kept to developement enviornments and not production.\n\n Equivlent to `console.debug()` in JavaScript.\nSynonyms:\nglimpse.debug\nglimpse debug","url":"glimpse.html#debug"},{"doc":"glimpse","title":"error","content":"pub fn error(term term: a) -&gt; a\n Use this to log errors in your program which shold be addressed. If\n it is an error your program is designed to catch and recover from,\n you probably don&#39;t need to log it.\n\n On erlang this will always evaluate the message to a string, even if\n the log isn&#39;t printed. This is because on JavaScript anything can be\n logged, so this makes more sense as a default as it lets us share one\n interface accross all targets. If you are on Erlang and want it only\n evaluated when logged, try [`lazy_error`] instead.\n\n Equivlent to `console.error()` in JavaScript.\n Equivlent to `error` in Erlang.\nSynonyms:\nglimpse.error\nglimpse error","url":"glimpse.html#error"},{"doc":"glimpse","title":"info","content":"pub fn info(term term: a) -&gt; a\n General information such as subprocess starts/stops, initalization\n information, and runtime logs.\n\n Equivlent to `console.log()` in JavaScript.\nSynonyms:\nglimpse.info\nglimpse info","url":"glimpse.html#info"},{"doc":"glimpse","title":"warn","content":"pub fn warn(term term: a) -&gt; a\n Runtime arnings which are of note.\n\n Equivlent to `console.warn()` in JavaScript.\nSynonyms:\nglimpse.warn\nglimpse warn","url":"glimpse.html#warn"},{"doc":"glimpse","title":"glimpse","content":"","url":"glimpse.html"},{"doc":"glimpse_log","title":"main","content":"pub fn main() -&gt; Int\n\nSynonyms:\nglimpse_log.main\nglimpse_log main","url":"glimpse_log.html#main"},{"doc":"glimpse_log","title":"glimpse_log","content":"","url":"glimpse_log.html"}]);